/**************************************************************
 * Send any comments or questions to: OTSO-Bug@tel.vtt.fi
 *
 * Name: /home/users/otso/official/otso/include/incfirst/SCCS/s.SIMU.hxx
 * Vers: 5.1    Time: 92/08/04, 12:59:40
 **************************************************************/

/***************************************************************
* Copyright (c) 1992      Technical Research Centre of Finland (VTT)
*
* Permission to use, copy, modify, and distribute this software and its
* documentation for any purpose and without fee is hereby granted, provided
* that this notice and the reference to this notice appearing in each software
* module be retained unaltered, and that the name of any contributors shall not
* be used in advertising or publicity pertaining to distribution of the software
* without specific written prior permission.  No contributor makes any
* representations about the suitability of this software for any purpose.
* It is provided "as is" without any express or limited warranty.
*
*			NO WARRANTY
*
* ALL CONTRIBUTORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
* INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTIBILITY AND FITNESS.  IN NO
* EVENT SHALL ANY CONTRIBUTOR BE LIABLE FOR ANY SPECIAL, PUNITIVE, INDIRECT OR
* CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
* DATA, OR PROFITS, WHETHER IN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
* TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH, THE USE OR PERFORMANCE
* OF THIS SOFTWARE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THIS
* SOFTWARE IS WITH YOU.  SHOULD THIS SOFTWARE PROVE DEFECTIVE, YOU ASSUME THE
* COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
*
* As used above, "contributor" includes, but is not limited to :
*        The Technical Research Centre of Finland
***************************************************************/


//	SIMU.hxx	- Juha 18.3.92

//OTSO.hxx should be included before this file.


/************ awesime headers **************************/

#if (!OTSO_SIMU_SELECT_INCLUDES) || (ACG_HXX == 1)
#include "ACG.h"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (BINOMIAL_HXX == 1)
#include "Binomial.h"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (DISCRETEUNIFORM_HXX == 1)
#include "DiscreteUniform.h"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (ERLANG_HXX == 1)
#include "Erlang.h"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (GEOMETRIC_HXX == 1)
#include "Geometric.h"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (HYPERGEOMETRIC_HXX == 1)
#include "HyperGeometric.h"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (MLCG_HXX == 1)
#include "MLCG.h"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (RANDOM_HXX == 1)
#include "Random.h"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (NEGATIVEEXPNTL_HXX == 1)
#include "NegativeExpntl.h"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (NORMAL_HXX == 1)
#include "Normal.h"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (LOGNORMAL_HXX == 0)
#include "LogNormal.h"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (POISSON_HXX == 1)
#include "Poisson.h"
#endif

#if (!OTSO_SIMU_SELECT_INCLUDES) || (RNG_HXX == 1)
#  ifndef FILE
#    include <stdio.h>					/*?*/
#  endif
#  include "RNG.h"
#endif

#if (!OTSO_SIMU_SELECT_INCLUDES) || (UNIFORM_HXX == 1)
#include "Uniform.h"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (WEIBULL_HXX == 1)
#include "Weibull.h"
#endif


/************* simres.hxx and statobj.hxx are included in OTSO.hxx ***/

//#if (!OTSO_SIMU_SELECT_INCLUDES) || (SIMRES_HXX == 1)
//#include "simres.hxx"
//#endif

//#if (!OTSO_SIMU_SELECT_INCLUDES) || (STATOBJ_HXX == 1)
//#include "statobj.hxx"
//#endif

/************* simsrc headers ***********************************/

#if (!OTSO_SIMU_SELECT_INCLUDES) || (VCLOCK_HXX == 1)
#include "vclock.hxx"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (EV_HXX == 1)
#include "ev.hxx"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (VOS_HXX == 1)
#include "vos.hxx"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (BT_HXX == 1)
#include "bt.hxx"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (SIMCTRL_HXX == 1)
#include "simctrl.hxx"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (TM_HXX == 1)
#include "tm.hxx"
#endif

#if (!OTSO_SIMU_SELECT_INCLUDES) || (CONSTRND_HXX == 1)
#include "constrnd.hxx"
#endif

#if (!OTSO_SIMU_SELECT_INCLUDES) || (COROUT_HXX == 1)
#ifndef LWP_EXT
#include "lwp.ext"
#endif
#include "corout.hxx"				      
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (CORUNNER_HXX == 1)
#include "corunner.hxx"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (LP_HXX == 1)
#include "lp.hxx"
#endif

#if (!OTSO_SIMU_SELECT_INCLUDES) || (VPR_HXX == 1)
#include "vpr.hxx"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (VPS_HXX == 1)
#include "vps.hxx"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (VAS_HXX == 1)
#include "vas.hxx"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (VTH_HXX == 1)
#include "vth.hxx"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (VDEV_HXX == 1)
#include "vdev.hxx"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (VIST_HXX == 1)
#include "vist.hxx"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (VOST_HXX == 1)
#include "vost.hxx"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (VCHA_HXX == 1)
#include "vcha.hxx"
#endif
#if (!OTSO_SIMU_SELECT_INCLUDES) || (VCON_HXX == 1)
#include "vcon.hxx"
#endif


