/**************************************************************
 * Send any comments or questions to: OTSO-Bug@tel.vtt.fi
 *
 * Name: /home/users/otso/official/otso/include/SCCS/s.inta.hxx
 * Vers: 5.3    Time: 92/08/14, 10:56:36
 **************************************************************/

/***************************************************************
* Copyright (c) 1992      Technical Research Centre of Finland (VTT)
*
* Permission to use, copy, modify, and distribute this software and its
* documentation for any purpose and without fee is hereby granted, provided
* that this notice and the reference to this notice appearing in each software
* module be retained unaltered, and that the name of any contributors shall not
* be used in advertising or publicity pertaining to distribution of the software
* without specific written prior permission.  No contributor makes any
* representations about the suitability of this software for any purpose.
* It is provided "as is" without any express or limited warranty.
*
*			NO WARRANTY
*
* ALL CONTRIBUTORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
* INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTIBILITY AND FITNESS.  IN NO
* EVENT SHALL ANY CONTRIBUTOR BE LIABLE FOR ANY SPECIAL, PUNITIVE, INDIRECT OR
* CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
* DATA, OR PROFITS, WHETHER IN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
* TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH, THE USE OR PERFORMANCE
* OF THIS SOFTWARE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THIS
* SOFTWARE IS WITH YOU.  SHOULD THIS SOFTWARE PROVE DEFECTIVE, YOU ASSUME THE
* COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
*
* As used above, "contributor" includes, but is not limited to :
*        The Technical Research Centre of Finland
***************************************************************/


/**********************************************************************
FILE inta.hxx: this is (mostly) generated code.
The output of running object.hxx, runner.hxx, and channel.hxx through prepro
is sent to inta.hxx and inta.cxx.  inta.sed and inta.hh
(and possibly manual corrections) are also needed when generating inta.hxx.
**********************************************************************/

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(Object);
/*DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(Runner);*/
/*DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(Message);*/
DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(Istream);
DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(Ostream);
DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(String);

/*****
*DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(MultiPtr);
*DECLARE_OTSO_PAED_FOR_ENUM(MultiPtr,MultiPtrState)
******/

#define RunnerPtr RunnerSPPtr

#ifndef EnumInfo_OTSO_HXX
#define EnumInfo_OTSO_HXX

/**********************************************************************
  Generated by OTSO prepro for class Object
**********************************************************************/

/******** _in, _out, _msg macros for function prototypes ********/
/* Do not use both _in and parameter format for one function */

#define printToDout_in printToDout()
#define printToDout_out printToDout()
#define printToDout_msg Object_printToDout()
#define askFromDin_in askFromDin()
#define askFromDin_out askFromDin()
#define askFromDin_msg Object_askFromDin()

/*********** _interface macro *******************************/

#define Object_interface \
  void printToDout_in; \
  void askFromDin_in

/*****************************************************************
Object interface object class 
*****************************************************************/
class Object_agent: public Agent {
  friend class ObjectPtr;
private:
  Object* sPInterface_;
  virtual void setSPInterface(void* p); //if p==0, uses this
  Object_agent(Object* spI, Object* spO, Process* spP,
		Object* suO, Process* suP, Agent::AgentState s);
public:
  redefined Object_interface;
  Object* sPInterface();
  ~Object_agent(); //?
  virtual String className() const;
};

/*****************************************************************
ObjectPtr is a kind of pointer to an OTSO Object that implements
Object.  It should be used instead of C++ a pointer (*) when
(concurrency-control or) messages are needed to provide support for
asynchronous message passing, tracing, or distribution.
ObjectPtr is a "user interface" to Object
interface objects (Object_agent).  The agents contain pointers 
to the service provider (SP) and service user (SU) objects.
ObjectPtr itself consists of two (?) pointers, so it is
not expensive to pass it as a pass-by-value argument in a function call.

Usage examples:
.nf
  SP sp;
  SU su;                  //contains ObjectPtr ptr;
  su.ptr = sp;            //sp must have operator ObjectPtr ()
.fi

Object* alone is not enough to build a ObjectPtr, 
so assigning a Object* to an ObjectPtr is not possible.
delete an ObjectPtr is not possible!
C++ pointers should not be used in OTSO system logical description (*.str).

*****************************************************************/

class ObjectPtr: public MultiPtr {
  friend class Object_agent;
  friend class Object_printToDout;
  friend class Object_askFromDin;
private:
  Object_agent* dap;
  ObjectPtr(sint8);	//Used by messages.
			//No agent allocated, setAgent() must be called soon.
  void setAgent(Object_agent*);
  void ifAgentIsSharedCreateANewOne();
public:
  Object* operator->();
  operator Object* ();
  ObjectPtr& operator=(const String& spName);
  ObjectPtr& operator=(const ObjectPtr&);
			//SU part not changed!
  virtual String className() const;
  virtual Agent* agent();
  virtual void ask(Istream&);
  virtual void from(IDump&);
  ObjectPtr();
			//Default constructor is used mainly by Runners that
			//have member Ptrs to other Runners.
			//By default SU is Runner::lastConstructedRunner.
			//If it is not ok, setAgent() should be called.
  ObjectPtr(Object* i, Object* o);
			//Called from implementation class
			//operator ObjectPtr().
  ObjectPtr(const Agent& sp);
			//Called in main() when sp represents a remote object.
			//NO type checking -- cannot guarantee that sp
			//implements Object!!!
  ObjectPtr(const ObjectPtr&);
 ~ObjectPtr();
};


/************** message class definitions *********/

/*****************************************************************
Output this to dout. 
*****************************************************************/
class Object_printToDout: public Message {
  friend class Object_agent;
private:
  ObjectPtr otsoPtr;
  virtual Agent* agent(); //shares SU's ObjectPtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(Object_printToDout);
public:
  Message* send();
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  Object_printToDout();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  ~Object_printToDout(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(Object_printToDout);

NewMsg* new_Object_printToDout(); //?

/*****************************************************************
Ask this from din. 
*****************************************************************/
class Object_askFromDin: public Message {
  friend class Object_agent;
private:
  ObjectPtr otsoPtr;
  virtual Agent* agent(); //shares SU's ObjectPtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(Object_askFromDin);
public:
  Message* send();
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  Object_askFromDin();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  ~Object_askFromDin(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(Object_askFromDin);

NewMsg* new_Object_askFromDin(); //?

#endif
DECLARE_OTSO_PAED_FOR_ENUM(RunStatus,RunStatusValue)

DECLARE_OTSO_PAED_FOR_ENUM(RunnerSP,RunnerPriority)

#ifndef RunnerTrace_OTSO_HXX
#define RunnerTrace_OTSO_HXX

/**********************************************************************
  Generated by OTSO prepro for class RunnerTrace
**********************************************************************/

/******** _in, _out, _msg macros for function prototypes ********/
/* Do not use both _in and parameter format for one function */

#define allOn_in allOn()
#define allOn_out allOn()
#define allOn_msg RunnerTrace_allOn()
#define allOff_in allOff()
#define allOff_out allOff()
#define allOff_msg RunnerTrace_allOff()
#define setDefault_in setDefault()
#define setDefault_out setDefault()
#define setDefault_msg RunnerTrace_setDefault()

/*********** _interface macro *******************************/

#define RunnerTrace_interface \
  async allOn_in; \
  async allOff_in; \
  async setDefault_in

/*****************************************************************
RunnerTrace interface object class 
*****************************************************************/
class RunnerTrace_agent: public RunnerTrace, public Agent {
  friend class RunnerTracePtr;
private:
  RunnerTrace* sPInterface_;
  virtual void setSPInterface(void* p); //if p==0, uses this
  RunnerTrace_agent(RunnerTrace* spI, Object* spO, Process* spP,
		Object* suO, Process* suP, Agent::AgentState s);
public:
  redefined RunnerTrace_interface;
  RunnerTrace* sPInterface();
  ~RunnerTrace_agent(); //?
  virtual String className() const;
};

/*****************************************************************
RunnerTracePtr is a kind of pointer to an OTSO Object that implements
RunnerTrace.  It should be used instead of C++ a pointer (*) when
(concurrency-control or) messages are needed to provide support for
asynchronous message passing, tracing, or distribution.
RunnerTracePtr is a "user interface" to RunnerTrace
interface objects (RunnerTrace_agent).  The agents contain pointers 
to the service provider (SP) and service user (SU) objects.
RunnerTracePtr itself consists of two (?) pointers, so it is
not expensive to pass it as a pass-by-value argument in a function call.

Usage examples:
.nf
  SP sp;
  SU su;                  //contains RunnerTracePtr ptr;
  su.ptr = sp;            //sp must have operator RunnerTracePtr ()
.fi

RunnerTrace* alone is not enough to build a RunnerTracePtr, 
so assigning a RunnerTrace* to an RunnerTracePtr is not possible.
delete an RunnerTracePtr is not possible!
C++ pointers should not be used in OTSO system logical description (*.str).

*****************************************************************/

class RunnerTracePtr: public MultiPtr {
  friend class RunnerTrace_agent;
  friend class RunnerTrace_allOn;
  friend class RunnerTrace_allOff;
  friend class RunnerTrace_setDefault;
private:
  RunnerTrace_agent* dap;
  RunnerTracePtr(sint8);	//Used by messages.
			//No agent allocated, setAgent() must be called soon.
  void setAgent(RunnerTrace_agent*);
  void ifAgentIsSharedCreateANewOne();
public:
  RunnerTrace* operator->();
  operator RunnerTrace* ();
  RunnerTracePtr& operator=(const String& spName);
  RunnerTracePtr& operator=(const RunnerTracePtr&);
			//SU part not changed!
  virtual String className() const;
  virtual Agent* agent();
  virtual void ask(Istream&);
  virtual void from(IDump&);
  RunnerTracePtr();
			//Default constructor is used mainly by Runners that
			//have member Ptrs to other Runners.
			//By default SU is Runner::lastConstructedRunner.
			//If it is not ok, setAgent() should be called.
  RunnerTracePtr(RunnerTrace* i, Object* o);
			//Called from implementation class
			//operator RunnerTracePtr().
  RunnerTracePtr(const Agent& sp);
			//Called in main() when sp represents a remote object.
			//NO type checking -- cannot guarantee that sp
			//implements RunnerTrace!!!
  RunnerTracePtr(const RunnerTracePtr&);
 ~RunnerTracePtr();
};


/************** message class definitions *********/

/*****************************************************************
Set all tracing on. 
*****************************************************************/
class RunnerTrace_allOn: public Message {
  friend class RunnerTrace_agent;
private:
  RunnerTracePtr otsoPtr;
  virtual Agent* agent(); //shares SU's RunnerTracePtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(RunnerTrace_allOn);
public:
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  RunnerTrace_allOn();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  ~RunnerTrace_allOn(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(RunnerTrace_allOn);

NewMsg* new_RunnerTrace_allOn(); //?

/*****************************************************************
Set all tracing off. 
*****************************************************************/
class RunnerTrace_allOff: public Message {
  friend class RunnerTrace_agent;
private:
  RunnerTracePtr otsoPtr;
  virtual Agent* agent(); //shares SU's RunnerTracePtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(RunnerTrace_allOff);
public:
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  RunnerTrace_allOff();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  ~RunnerTrace_allOff(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(RunnerTrace_allOff);

NewMsg* new_RunnerTrace_allOff(); //?

/*****************************************************************
Set default tracing on. 
*****************************************************************/
class RunnerTrace_setDefault: public Message {
  friend class RunnerTrace_agent;
private:
  RunnerTracePtr otsoPtr;
  virtual Agent* agent(); //shares SU's RunnerTracePtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(RunnerTrace_setDefault);
public:
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  RunnerTrace_setDefault();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  ~RunnerTrace_setDefault(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(RunnerTrace_setDefault);

NewMsg* new_RunnerTrace_setDefault(); //?


/**********************************************************************
  Generated by OTSO prepro for class RunnerSP
**********************************************************************/

/******** _in, _out, _msg macros for function prototypes ********/
/* Do not use both _in and parameter format for one function */

#define run_in run()
#define run_out run()
#define run_msg RunnerSP_run()
#define run1_in run1()
#define run1_out run1()
#define run1_msg RunnerSP_run1()
#define setPriority_in setPriority(RunnerSP::RunnerPriority priority)
#define setPriority_out setPriority(priority)
#define setPriority_msg RunnerSP_setPriority(priority)
#define timeout_in timeout(sint32 id)
#define timeout_out timeout(id)
#define timeout_msg RunnerSP_timeout(id)

/*********** _interface macro *******************************/

#define RunnerSP_interface \
  void run_in; \
  void run1_in; \
  void setPriority_in; \
  async timeout_in

/*****************************************************************
RunnerSP interface object class 
*****************************************************************/
class RunnerSP_agent: public RunnerSP, public Agent {
  friend class RunnerSPPtr;
private:
  RunnerSP* sPInterface_;
  virtual void setSPInterface(void* p); //if p==0, uses this
  RunnerSP_agent(RunnerSP* spI, Object* spO, Process* spP,
		Object* suO, Process* suP, Agent::AgentState s);
public:
  redefined RunnerSP_interface;
  RunnerSP* sPInterface();
  ~RunnerSP_agent(); //?
  virtual String className() const;
};

/*****************************************************************
RunnerSPPtr is a kind of pointer to an OTSO Object that implements
RunnerSP.  It should be used instead of C++ a pointer (*) when
(concurrency-control or) messages are needed to provide support for
asynchronous message passing, tracing, or distribution.
RunnerSPPtr is a "user interface" to RunnerSP
interface objects (RunnerSP_agent).  The agents contain pointers 
to the service provider (SP) and service user (SU) objects.
RunnerSPPtr itself consists of two (?) pointers, so it is
not expensive to pass it as a pass-by-value argument in a function call.

Usage examples:
.nf
  SP sp;
  SU su;                  //contains RunnerSPPtr ptr;
  su.ptr = sp;            //sp must have operator RunnerSPPtr ()
.fi

RunnerSP* alone is not enough to build a RunnerSPPtr, 
so assigning a RunnerSP* to an RunnerSPPtr is not possible.
delete an RunnerSPPtr is not possible!
C++ pointers should not be used in OTSO system logical description (*.str).

*****************************************************************/

class RunnerSPPtr: public MultiPtr {
  friend class RunnerSP_agent;
  friend class RunnerSP_run;
  friend class RunnerSP_run1;
  friend class RunnerSP_setPriority;
  friend class RunnerSP_timeout;
private:
  RunnerSP_agent* dap;
  RunnerSPPtr(sint8);	//Used by messages.
			//No agent allocated, setAgent() must be called soon.
  void setAgent(RunnerSP_agent*);
  void ifAgentIsSharedCreateANewOne();
public:
  RunnerSP* operator->();
  operator RunnerSP* ();
  RunnerSPPtr& operator=(const String& spName);
  RunnerSPPtr& operator=(const RunnerSPPtr&);
			//SU part not changed!
  virtual String className() const;
  virtual Agent* agent();
  virtual void ask(Istream&);
  virtual void from(IDump&);
  RunnerSPPtr();
			//Default constructor is used mainly by Runners that
			//have member Ptrs to other Runners.
			//By default SU is Runner::lastConstructedRunner.
			//If it is not ok, setAgent() should be called.
  RunnerSPPtr(RunnerSP* i, Object* o);
			//Called from implementation class
			//operator RunnerSPPtr().
  RunnerSPPtr(const Agent& sp);
			//Called in main() when sp represents a remote object.
			//NO type checking -- cannot guarantee that sp
			//implements RunnerSP!!!
  RunnerSPPtr(const RunnerSPPtr&);
 ~RunnerSPPtr();
};


/************** message class definitions *********/

/*****************************************************************
Activates this to perform actions. 
*****************************************************************/
class RunnerSP_run: public Message {
  friend class RunnerSP_agent;
private:
  RunnerSPPtr otsoPtr;
  virtual Agent* agent(); //shares SU's RunnerSPPtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(RunnerSP_run);
public:
  Message* send();
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  RunnerSP_run();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  ~RunnerSP_run(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(RunnerSP_run);

NewMsg* new_RunnerSP_run(); //?

/*****************************************************************
Activates this to handle one event. 
*****************************************************************/
class RunnerSP_run1: public Message {
  friend class RunnerSP_agent;
private:
  RunnerSPPtr otsoPtr;
  virtual Agent* agent(); //shares SU's RunnerSPPtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(RunnerSP_run1);
public:
  Message* send();
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  RunnerSP_run1();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  ~RunnerSP_run1(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(RunnerSP_run1);

NewMsg* new_RunnerSP_run1(); //?

/*****************************************************************
Set the priority. 
*****************************************************************/
class RunnerSP_setPriority: public Message {
  friend class RunnerSP_agent;
private:
  RunnerSPPtr otsoPtr;
  virtual Agent* agent(); //shares SU's RunnerSPPtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(RunnerSP_setPriority);
  /****** function arguments ******/
  RunnerSP::RunnerPriority priority;
public:
  Message* send();
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  virtual void outEncode(ODump&);
  virtual void outDecode(IDump&);
  RunnerSP_setPriority();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  RunnerSP_setPriority(RunnerSP::RunnerPriority priority); //called by RunnerSP_agent
  ~RunnerSP_setPriority(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(RunnerSP_setPriority);

NewMsg* new_RunnerSP_setPriority(); //?

/*****************************************************************
  
*****************************************************************/
class RunnerSP_timeout: public Message {
  friend class RunnerSP_agent;
private:
  RunnerSPPtr otsoPtr;
  virtual Agent* agent(); //shares SU's RunnerSPPtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(RunnerSP_timeout);
  /****** function arguments ******/
  sint32 id;
public:
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  RunnerSP_timeout();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  RunnerSP_timeout(sint32 id); //called by RunnerSP_agent
  ~RunnerSP_timeout(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(RunnerSP_timeout);

NewMsg* new_RunnerSP_timeout(); //?

#endif
#ifndef Channel_OTSO_HXX
#define Channel_OTSO_HXX

/**********************************************************************
  Generated by OTSO prepro for class IstreamSP
**********************************************************************/

/******** _in, _out, _msg macros for function prototypes ********/
/* Do not use both _in and parameter format for one function */

#define Exit_in Exit()
#define Exit_out Exit()
#define Exit_msg IstreamSP_Exit()
#define debug_in debug()
#define debug_out debug()
#define debug_msg IstreamSP_debug()
#define outputRedirection_in outputRedirection(String filename, boolean isDoutLoggingThereToo)
#define outputRedirection_out outputRedirection(filename, isDoutLoggingThereToo)
#define outputRedirection_msg IstreamSP_outputRedirection(filename, isDoutLoggingThereToo)
#define inputRedirection_in inputRedirection(String filename)
#define inputRedirection_out inputRedirection(filename)
#define inputRedirection_msg IstreamSP_inputRedirection(filename)
#define logInputToFile_in logInputToFile(boolean yes_1_or_no_0)
#define logInputToFile_out logInputToFile(yes_1_or_no_0)
#define logInputToFile_msg IstreamSP_logInputToFile(yes_1_or_no_0)

/*********** _interface macro *******************************/

#define IstreamSP_interface \
  void Exit_in; \
  void debug_in; \
  void outputRedirection_in; \
  void inputRedirection_in; \
  void logInputToFile_in

/*****************************************************************
IstreamSP interface object class 
*****************************************************************/
class IstreamSP_agent: public IstreamSP, public Agent {
  friend class IstreamSPPtr;
private:
  IstreamSP* sPInterface_;
  virtual void setSPInterface(void* p); //if p==0, uses this
  IstreamSP_agent(IstreamSP* spI, Object* spO, Process* spP,
		Object* suO, Process* suP, Agent::AgentState s);
public:
  redefined IstreamSP_interface;
  IstreamSP* sPInterface();
  ~IstreamSP_agent(); //?
  virtual String className() const;
};

/*****************************************************************
IstreamSPPtr is a kind of pointer to an OTSO Object that implements
IstreamSP.  It should be used instead of C++ a pointer (*) when
(concurrency-control or) messages are needed to provide support for
asynchronous message passing, tracing, or distribution.
IstreamSPPtr is a "user interface" to IstreamSP
interface objects (IstreamSP_agent).  The agents contain pointers 
to the service provider (SP) and service user (SU) objects.
IstreamSPPtr itself consists of two (?) pointers, so it is
not expensive to pass it as a pass-by-value argument in a function call.

Usage examples:
.nf
  SP sp;
  SU su;                  //contains IstreamSPPtr ptr;
  su.ptr = sp;            //sp must have operator IstreamSPPtr ()
.fi

IstreamSP* alone is not enough to build a IstreamSPPtr, 
so assigning a IstreamSP* to an IstreamSPPtr is not possible.
delete an IstreamSPPtr is not possible!
C++ pointers should not be used in OTSO system logical description (*.str).

*****************************************************************/

class IstreamSPPtr: public MultiPtr {
  friend class IstreamSP_agent;
  friend class IstreamSP_Exit;
  friend class IstreamSP_debug;
  friend class IstreamSP_outputRedirection;
  friend class IstreamSP_inputRedirection;
  friend class IstreamSP_logInputToFile;
private:
  IstreamSP_agent* dap;
  IstreamSPPtr(sint8);	//Used by messages.
			//No agent allocated, setAgent() must be called soon.
  void setAgent(IstreamSP_agent*);
  void ifAgentIsSharedCreateANewOne();
public:
  IstreamSP* operator->();
  operator IstreamSP* ();
  IstreamSPPtr& operator=(const String& spName);
  IstreamSPPtr& operator=(const IstreamSPPtr&);
			//SU part not changed!
  virtual String className() const;
  virtual Agent* agent();
  virtual void ask(Istream&);
  virtual void from(IDump&);
  IstreamSPPtr();
			//Default constructor is used mainly by Runners that
			//have member Ptrs to other Runners.
			//By default SU is Runner::lastConstructedRunner.
			//If it is not ok, setAgent() should be called.
  IstreamSPPtr(IstreamSP* i, Object* o);
			//Called from implementation class
			//operator IstreamSPPtr().
  IstreamSPPtr(const Agent& sp);
			//Called in main() when sp represents a remote object.
			//NO type checking -- cannot guarantee that sp
			//implements IstreamSP!!!
  IstreamSPPtr(const IstreamSPPtr&);
 ~IstreamSPPtr();
};


/************** message class definitions *********/

/*****************************************************************
  exit OTSO 
*****************************************************************/
class IstreamSP_Exit: public Message {
  friend class IstreamSP_agent;
private:
  IstreamSPPtr otsoPtr;
  virtual Agent* agent(); //shares SU's IstreamSPPtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(IstreamSP_Exit);
public:
  Message* send();
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  IstreamSP_Exit();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  ~IstreamSP_Exit(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(IstreamSP_Exit);

NewMsg* new_IstreamSP_Exit(); //?

/*****************************************************************
Go to debugger (set a break point in ::debug()) 
*****************************************************************/
class IstreamSP_debug: public Message {
  friend class IstreamSP_agent;
private:
  IstreamSPPtr otsoPtr;
  virtual Agent* agent(); //shares SU's IstreamSPPtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(IstreamSP_debug);
public:
  Message* send();
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  IstreamSP_debug();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  ~IstreamSP_debug(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(IstreamSP_debug);

NewMsg* new_IstreamSP_debug(); //?

/*****************************************************************
logging: copy input and output  to a file 
*****************************************************************/
class IstreamSP_outputRedirection: public Message {
  friend class IstreamSP_agent;
private:
  IstreamSPPtr otsoPtr;
  virtual Agent* agent(); //shares SU's IstreamSPPtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(IstreamSP_outputRedirection);
  /****** function arguments ******/
  String filename;
  boolean isDoutLoggingThereToo;
public:
  Message* send();
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  virtual void outEncode(ODump&);
  virtual void outDecode(IDump&);
  IstreamSP_outputRedirection();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  IstreamSP_outputRedirection(String filename, boolean isDoutLoggingThereToo); //called by IstreamSP_agent
  ~IstreamSP_outputRedirection(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(IstreamSP_outputRedirection);

NewMsg* new_IstreamSP_outputRedirection(); //?

/*****************************************************************
read command input from a file 
*****************************************************************/
class IstreamSP_inputRedirection: public Message {
  friend class IstreamSP_agent;
private:
  IstreamSPPtr otsoPtr;
  virtual Agent* agent(); //shares SU's IstreamSPPtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(IstreamSP_inputRedirection);
  /****** function arguments ******/
  String filename;
public:
  Message* send();
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  virtual void outEncode(ODump&);
  virtual void outDecode(IDump&);
  IstreamSP_inputRedirection();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  IstreamSP_inputRedirection(String filename); //called by IstreamSP_agent
  ~IstreamSP_inputRedirection(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(IstreamSP_inputRedirection);

NewMsg* new_IstreamSP_inputRedirection(); //?

/*****************************************************************
Set din input logging to file  on or off. 
*****************************************************************/
class IstreamSP_logInputToFile: public Message {
  friend class IstreamSP_agent;
private:
  IstreamSPPtr otsoPtr;
  virtual Agent* agent(); //shares SU's IstreamSPPtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(IstreamSP_logInputToFile);
  /****** function arguments ******/
  boolean yes_1_or_no_0;
public:
  Message* send();
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  virtual void outEncode(ODump&);
  virtual void outDecode(IDump&);
  IstreamSP_logInputToFile();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  IstreamSP_logInputToFile(boolean yes_1_or_no_0); //called by IstreamSP_agent
  ~IstreamSP_logInputToFile(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(IstreamSP_logInputToFile);

NewMsg* new_IstreamSP_logInputToFile(); //?


/**********************************************************************
  Generated by OTSO prepro for class OstreamSP
**********************************************************************/

/******** _in, _out, _msg macros for function prototypes ********/
/* Do not use both _in and parameter format for one function */

#define outputLogging_in outputLogging(String filename, boolean isDinLoggingThereToo)
#define outputLogging_out outputLogging(filename, isDinLoggingThereToo)
#define outputLogging_msg OstreamSP_outputLogging(filename, isDinLoggingThereToo)
#define logOutputToFile_in logOutputToFile(boolean yes_1_or_no_0)
#define logOutputToFile_out logOutputToFile(yes_1_or_no_0)
#define logOutputToFile_msg OstreamSP_logOutputToFile(yes_1_or_no_0)

/*********** _interface macro *******************************/

#define OstreamSP_interface \
  void outputLogging_in; \
  void logOutputToFile_in

/*****************************************************************
OstreamSP interface object class 
*****************************************************************/
class OstreamSP_agent: public OstreamSP, public Agent {
  friend class OstreamSPPtr;
private:
  OstreamSP* sPInterface_;
  virtual void setSPInterface(void* p); //if p==0, uses this
  OstreamSP_agent(OstreamSP* spI, Object* spO, Process* spP,
		Object* suO, Process* suP, Agent::AgentState s);
public:
  redefined OstreamSP_interface;
  OstreamSP* sPInterface();
  ~OstreamSP_agent(); //?
  virtual String className() const;
};

/*****************************************************************
OstreamSPPtr is a kind of pointer to an OTSO Object that implements
OstreamSP.  It should be used instead of C++ a pointer (*) when
(concurrency-control or) messages are needed to provide support for
asynchronous message passing, tracing, or distribution.
OstreamSPPtr is a "user interface" to OstreamSP
interface objects (OstreamSP_agent).  The agents contain pointers 
to the service provider (SP) and service user (SU) objects.
OstreamSPPtr itself consists of two (?) pointers, so it is
not expensive to pass it as a pass-by-value argument in a function call.

Usage examples:
.nf
  SP sp;
  SU su;                  //contains OstreamSPPtr ptr;
  su.ptr = sp;            //sp must have operator OstreamSPPtr ()
.fi

OstreamSP* alone is not enough to build a OstreamSPPtr, 
so assigning a OstreamSP* to an OstreamSPPtr is not possible.
delete an OstreamSPPtr is not possible!
C++ pointers should not be used in OTSO system logical description (*.str).

*****************************************************************/

class OstreamSPPtr: public MultiPtr {
  friend class OstreamSP_agent;
  friend class OstreamSP_outputLogging;
  friend class OstreamSP_logOutputToFile;
private:
  OstreamSP_agent* dap;
  OstreamSPPtr(sint8);	//Used by messages.
			//No agent allocated, setAgent() must be called soon.
  void setAgent(OstreamSP_agent*);
  void ifAgentIsSharedCreateANewOne();
public:
  OstreamSP* operator->();
  operator OstreamSP* ();
  OstreamSPPtr& operator=(const String& spName);
  OstreamSPPtr& operator=(const OstreamSPPtr&);
			//SU part not changed!
  virtual String className() const;
  virtual Agent* agent();
  virtual void ask(Istream&);
  virtual void from(IDump&);
  OstreamSPPtr();
			//Default constructor is used mainly by Runners that
			//have member Ptrs to other Runners.
			//By default SU is Runner::lastConstructedRunner.
			//If it is not ok, setAgent() should be called.
  OstreamSPPtr(OstreamSP* i, Object* o);
			//Called from implementation class
			//operator OstreamSPPtr().
  OstreamSPPtr(const Agent& sp);
			//Called in main() when sp represents a remote object.
			//NO type checking -- cannot guarantee that sp
			//implements OstreamSP!!!
  OstreamSPPtr(const OstreamSPPtr&);
 ~OstreamSPPtr();
};


/************** message class definitions *********/

/*****************************************************************
  logging: copy (!) output to file 
*****************************************************************/
class OstreamSP_outputLogging: public Message {
  friend class OstreamSP_agent;
private:
  OstreamSPPtr otsoPtr;
  virtual Agent* agent(); //shares SU's OstreamSPPtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(OstreamSP_outputLogging);
  /****** function arguments ******/
  String filename;
  boolean isDinLoggingThereToo;
public:
  Message* send();
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  virtual void outEncode(ODump&);
  virtual void outDecode(IDump&);
  OstreamSP_outputLogging();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  OstreamSP_outputLogging(String filename, boolean isDinLoggingThereToo); //called by OstreamSP_agent
  ~OstreamSP_outputLogging(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(OstreamSP_outputLogging);

NewMsg* new_OstreamSP_outputLogging(); //?

/*****************************************************************
Logging dout output to file: set on or off. 
*****************************************************************/
class OstreamSP_logOutputToFile: public Message {
  friend class OstreamSP_agent;
private:
  OstreamSPPtr otsoPtr;
  virtual Agent* agent(); //shares SU's OstreamSPPtr's agent
  virtual void run();
  DECLARE_OTSO_MEMBERS_FOR_THIS_CLASS(OstreamSP_logOutputToFile);
  /****** function arguments ******/
  boolean yes_1_or_no_0;
public:
  Message* send();
  virtual String className() const;
  virtual MultiPtr* multiPtr();
  virtual void outEncode(ODump&);
  virtual void outDecode(IDump&);
  OstreamSP_logOutputToFile();	//called by Istreams; they must 
			//call setSource(), setSourceName() and setDest().
  OstreamSP_logOutputToFile(boolean yes_1_or_no_0); //called by OstreamSP_agent
  ~OstreamSP_logOutputToFile(); //?
};

DECLARE_OTSO_PAED_FOR_OTSO_OBJECT(OstreamSP_logOutputToFile);

NewMsg* new_OstreamSP_logOutputToFile(); //?

#endif
