


VirtualTerminal(3)     C LIBRARY FUNCTIONS     VirtualTerminal(3)



CLASS
     VirtualTerminal


DESCRIPTION
     This is the Base  class  for  all  dvops  terminal  classes.
     Basically  a terminal class should be conceptually a collec-
     tion of an input, output, error, and log  streams.   It  was
     problematic,  that  when  dvops was originally written, many
     objects would have only either an istream or an ostream (via
     a ptr, reference) and then the user might require an ostream
     or istream that was tied to the original,  but  they  didn't
     have  one,  so they just used cin, cout, printf, scanf, etc.
     This was VERY ugly.  So a terminal class  was  invented,  so
     the  programmer  could  deal  conceptually  with  terminals,
     although they are really collections  of  input  and  output
     streams.


USAGE
     - operator << uses the output stream

     - operator >> uses the inputstream

     - perror, xerror, error, dverror are provided for the error streams
       (formatted output).

     - unformatted output to a terminal log or error stream must take
       place through the appropriate class member.


NOTE
     - An attempt has been made to make the terminal class portable to
     g++ or ATT Cfront 2.0+ compilers.  They implement istreams/ostreams
     differently.

     - Users are heavily ENCOURAGED to NEVER again use C++ cout, cin, etc.

     - PLEASE try to use DVOPS terminals whenever possible !

     - PLEASE try to use the defined terminal error functions when possible
     too, they are easy to use, fun, and may make your life easier.

     - Someday, support for a derived X Window terminal class will
     be added to DVOPS.


PUBLIC MEMBERS
     ostream& log
           constructors

     ostream_withassign log



Sun Release 4.0          Last change: -                         1






VirtualTerminal(3)     C LIBRARY FUNCTIONS     VirtualTerminal(3)



           constructors

     virtual void badOp()
           output stream (formatted output to member out)

     VirtualTerminal& form
           output stream (unformatted output to member out) input
          stream (unformatted input from member in)  virtual Vir-
          tualTerminal&  operator>>  (whitespace&)   {   badOp();
          return  *this;  }   error  stream  (formatted output to
          member err)  user error  dvops error  sys error - errno
          fatal error  log stream (formatted ouput to member log)
          log to logfile


PUBLIC CONSTRUCTORS AND CONVERSIONS
      VirtualTerminal(istream& lin  =cin,  ostream&  lout  =cout,
     ostream& lerr =cerr, ostream& llog =clog)


      VirtualTerminal(VirtualTerminal& ui)


      VirtualTerminal(istream& lin  =cin,  ostream&  lout  =cout,
     ostream& lerr =cerr, ostream& llog =clog)


      VirtualTerminal(VirtualTerminal& ui)
           I/O members



FILE
     virtual_term.hxx





















Sun Release 4.0          Last change: -                         2



